package logwire.web.bo;

import logwire.core.bo.handler.OperationHandler;
import logwire.core.bo.object.BizObject;
import logwire.core.meta.Config;
import logwire.core.resource.bean.BeanAdapter;

import java.util.ArrayList;
import java.util.List;

public class BoRelationDefinition extends BeanAdapter {

    public BoRelationDefinition(){

    }
    private boolean boServiceInitialized;

    @Config
    boolean isBizModel = false;

    @Config
    private Class<? extends BizObject> boClass;

    @Config
    private List<Class> typeOperationProviders = new ArrayList<>();

    @Config
    private List<Class> objectOperationProviders = new ArrayList<>();

    @Config
    private List<Class> listOperationProviders = new ArrayList<>();

    @Config
    private List<OperationHandler> typeOperationHandlers = new ArrayList<>();

    @Config
    private List<Class> objectOperationHandlers = new ArrayList<>();

    @Config
    private List<Class> listOperationHandlers = new ArrayList<>();


    public List<Class> getTypeOperationProviders() {
        return typeOperationProviders;
    }

    public void setTypeOperationProviders(List<Class> typeOperationProviders) {
        this.typeOperationProviders = typeOperationProviders;
    }

    public void addTypeOperationProvider(Class typeOperationProvider) {
        this.typeOperationProviders.add(typeOperationProvider);
    }


    public List<Class> getObjectOperationProviders() {
        return objectOperationProviders;
    }

    public void setObjectOperationProviders(List<Class> objectOperationProviders) {
        this.objectOperationProviders = objectOperationProviders;
    }

    public void addObjectOperationProvider(Class objectOperationProvider) {
        this.objectOperationProviders.add(objectOperationProvider);
    }

    public List<Class> getListOperationProviders() {
        return listOperationProviders;
    }

    public void setListOperationProviders(List<Class> listOperationProviders) {
        this.listOperationProviders = listOperationProviders;
    }

    public void addListOperationProvider(Class listOperationProvider) {
        this.listOperationProviders.add(listOperationProvider);
    }

    public List<OperationHandler> getTypeOperationHandlers() {
        return typeOperationHandlers;
    }

    public void setTypeOperationHandlers(List<OperationHandler> typeOperationHandlers) {
        this.typeOperationHandlers = typeOperationHandlers;
    }

    public List<Class> getObjectOperationHandlers() {
        return objectOperationHandlers;
    }

    public void setObjectOperationHandlers(List<Class> objectOperationHandlers) {
        this.objectOperationHandlers = objectOperationHandlers;
    }

    public List<Class> getListOperationHandlers() {
        return listOperationHandlers;
    }

    public void setListOperationHandlers(List<Class> listOperationHandlers) {
        this.listOperationHandlers = listOperationHandlers;
    }


    public boolean isBizModel() {
        return isBizModel;
    }

    public void setBizModel(boolean bizModel) {
        isBizModel = bizModel;
    }


    public Class<? extends BizObject> getBoClass() {
        return boClass;
    }

    public void setBoClass(Class<? extends BizObject> boClass) {
        this.boClass = boClass;
    }

    public boolean isBoServiceInitialized() {
        return boServiceInitialized;
    }

    public void setBoServiceInitialized(boolean boServiceInitialized) {
        this.boServiceInitialized = boServiceInitialized;
    }
}
