package logwire.web.bo.container;

import logwire.core.resource.*;
import logwire.web.bo.loader.BoRelationBeanDefinitionLoader;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

@Component
public class BoRelationBeanContainerBuilder implements JavaBeanContainerBuilder {
    @Override
    public JavaBeanContainer build(ApplicationContext applicationContext) {
        return newContainer(applicationContext, BoRelationBeanDefinitionLoader.class);
    }

    @Override
    public String getContainerName() {
        return "BO_RELATION";
    }


    private JavaBeanContainer newContainer(ApplicationContext ctx, Class... classes) {
        BeanLoader[] loaders = new BeanLoader[classes.length];
        for (int i = 0; i < loaders.length; i++) {
            loaders[i] = (BeanLoader) Util.getExactBean(ctx, classes[i]);
        }
        JavaBeanContainer container = new JavaBeanContainer(loaders);
        return container;
    }
}
